<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestAuthenticationStrategy xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../testapidocs/org/apache/http/impl/client/TestAuthenticationStrategy.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.client;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> java.util.Arrays;
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.util.Queue;
<a class="jxr_linenumber" name="33" href="#33">33</a>  
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Header;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpHost;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponse;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpStatus;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpVersion;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.auth.AUTH;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.auth.AuthOption;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.auth.AuthScheme;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.auth.AuthSchemeProvider;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.auth.AuthScope;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.auth.UsernamePasswordCredentials;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.AuthCache;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.CredentialsProvider;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.config.AuthSchemes;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.config.RequestConfig;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.protocol.ClientContext;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.config.Registry;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.apache.http.config.RegistryBuilder;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.auth.BasicScheme;
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.auth.BasicSchemeFactory;
<a class="jxr_linenumber" name="54" href="#54">54</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.auth.DigestScheme;
<a class="jxr_linenumber" name="55" href="#55">55</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.auth.DigestSchemeFactory;
<a class="jxr_linenumber" name="56" href="#56">56</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHeader;
<a class="jxr_linenumber" name="57" href="#57">57</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHttpResponse;
<a class="jxr_linenumber" name="58" href="#58">58</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.BasicHttpContext;
<a class="jxr_linenumber" name="59" href="#59">59</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpContext;
<a class="jxr_linenumber" name="60" href="#60">60</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="61" href="#61">61</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="62" href="#62">62</a>  <strong class="jxr_keyword">import</strong> org.mockito.Mockito;
<a class="jxr_linenumber" name="63" href="#63">63</a>  
<a class="jxr_linenumber" name="64" href="#64">64</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_javadoccomment"> * Simple tests for {@link AuthenticationStrategyImpl}.</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/impl/client/TestAuthenticationStrategy.html">TestAuthenticationStrategy</a> {
<a class="jxr_linenumber" name="68" href="#68">68</a>  
<a class="jxr_linenumber" name="69" href="#69">69</a>      @Test(expected=IllegalArgumentException.<strong class="jxr_keyword">class</strong>)
<a class="jxr_linenumber" name="70" href="#70">70</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testIsAuthenticationRequestedInvalidInput() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="71" href="#71">71</a>          <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="72" href="#72">72</a>          <strong class="jxr_keyword">final</strong> HttpHost host = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80);
<a class="jxr_linenumber" name="73" href="#73">73</a>          <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="74" href="#74">74</a>          authStrategy.isAuthenticationRequested(host, <strong class="jxr_keyword">null</strong>, context);
<a class="jxr_linenumber" name="75" href="#75">75</a>      }
<a class="jxr_linenumber" name="76" href="#76">76</a>  
<a class="jxr_linenumber" name="77" href="#77">77</a>      @Test
<a class="jxr_linenumber" name="78" href="#78">78</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testTargetAuthRequested() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="79" href="#79">79</a>          <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="80" href="#80">80</a>          <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="81" href="#81">81</a>          <strong class="jxr_keyword">final</strong> HttpHost host = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80);
<a class="jxr_linenumber" name="82" href="#82">82</a>          <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="83" href="#83">83</a>          Assert.assertTrue(authStrategy.isAuthenticationRequested(host, response, context));
<a class="jxr_linenumber" name="84" href="#84">84</a>      }
<a class="jxr_linenumber" name="85" href="#85">85</a>  
<a class="jxr_linenumber" name="86" href="#86">86</a>      @Test
<a class="jxr_linenumber" name="87" href="#87">87</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testProxyAuthRequested() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="88" href="#88">88</a>          <strong class="jxr_keyword">final</strong> ProxyAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> ProxyAuthenticationStrategy();
<a class="jxr_linenumber" name="89" href="#89">89</a>          <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_PROXY_AUTHENTICATION_REQUIRED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="90" href="#90">90</a>          <strong class="jxr_keyword">final</strong> HttpHost host = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80);
<a class="jxr_linenumber" name="91" href="#91">91</a>          <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="92" href="#92">92</a>          Assert.assertTrue(authStrategy.isAuthenticationRequested(host, response, context));
<a class="jxr_linenumber" name="93" href="#93">93</a>      }
<a class="jxr_linenumber" name="94" href="#94">94</a>  
<a class="jxr_linenumber" name="95" href="#95">95</a>      @Test(expected=IllegalArgumentException.<strong class="jxr_keyword">class</strong>)
<a class="jxr_linenumber" name="96" href="#96">96</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testGetChallengesInvalidInput() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="97" href="#97">97</a>          <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="98" href="#98">98</a>          <strong class="jxr_keyword">final</strong> HttpHost host = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80);
<a class="jxr_linenumber" name="99" href="#99">99</a>          <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="100" href="#100">100</a>         authStrategy.getChallenges(host, <strong class="jxr_keyword">null</strong>, context);
<a class="jxr_linenumber" name="101" href="#101">101</a>     }
<a class="jxr_linenumber" name="102" href="#102">102</a> 
<a class="jxr_linenumber" name="103" href="#103">103</a>     @Test
<a class="jxr_linenumber" name="104" href="#104">104</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testGetChallenges() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="105" href="#105">105</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="106" href="#106">106</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="107" href="#107">107</a>         <strong class="jxr_keyword">final</strong> HttpHost host = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80);
<a class="jxr_linenumber" name="108" href="#108">108</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="109" href="#109">109</a>         <strong class="jxr_keyword">final</strong> Header h1 = <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"  Basic  realm=\&quot;test\&quot;"</span>);
<a class="jxr_linenumber" name="110" href="#110">110</a>         <strong class="jxr_keyword">final</strong> Header h2 = <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"\t\tDigest   realm=\&quot;realm1\&quot;, nonce=\&quot;1234\&quot;"</span>);
<a class="jxr_linenumber" name="111" href="#111">111</a>         <strong class="jxr_keyword">final</strong> Header h3 = <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"WhatEver realm=\&quot;realm1\&quot;, stuff=\&quot;1234\&quot;"</span>);
<a class="jxr_linenumber" name="112" href="#112">112</a>         response.addHeader(h1);
<a class="jxr_linenumber" name="113" href="#113">113</a>         response.addHeader(h2);
<a class="jxr_linenumber" name="114" href="#114">114</a>         response.addHeader(h3);
<a class="jxr_linenumber" name="115" href="#115">115</a> 
<a class="jxr_linenumber" name="116" href="#116">116</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = authStrategy.getChallenges(host, response, context);
<a class="jxr_linenumber" name="117" href="#117">117</a> 
<a class="jxr_linenumber" name="118" href="#118">118</a>         Assert.assertNotNull(challenges);
<a class="jxr_linenumber" name="119" href="#119">119</a>         Assert.assertEquals(3, challenges.size());
<a class="jxr_linenumber" name="120" href="#120">120</a>         Assert.assertSame(h1, challenges.get(<span class="jxr_string">"basic"</span>));
<a class="jxr_linenumber" name="121" href="#121">121</a>         Assert.assertSame(h2, challenges.get(<span class="jxr_string">"digest"</span>));
<a class="jxr_linenumber" name="122" href="#122">122</a>         Assert.assertSame(h3, challenges.get(<span class="jxr_string">"whatever"</span>));
<a class="jxr_linenumber" name="123" href="#123">123</a>     }
<a class="jxr_linenumber" name="124" href="#124">124</a> 
<a class="jxr_linenumber" name="125" href="#125">125</a>     @Test
<a class="jxr_linenumber" name="126" href="#126">126</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testSelectInvalidInput() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="127" href="#127">127</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="128" href="#128">128</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Header&gt;();
<a class="jxr_linenumber" name="129" href="#129">129</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="130" href="#130">130</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"locahost"</span>, 80);
<a class="jxr_linenumber" name="131" href="#131">131</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="132" href="#132">132</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="133" href="#133">133</a>             authStrategy.select(<strong class="jxr_keyword">null</strong>, authhost, response, context);
<a class="jxr_linenumber" name="134" href="#134">134</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="135" href="#135">135</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="136" href="#136">136</a>         }
<a class="jxr_linenumber" name="137" href="#137">137</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="138" href="#138">138</a>             authStrategy.select(challenges, <strong class="jxr_keyword">null</strong>, response, context);
<a class="jxr_linenumber" name="139" href="#139">139</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="140" href="#140">140</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="141" href="#141">141</a>         }
<a class="jxr_linenumber" name="142" href="#142">142</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="143" href="#143">143</a>             authStrategy.select(challenges, authhost, <strong class="jxr_keyword">null</strong>, context);
<a class="jxr_linenumber" name="144" href="#144">144</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="145" href="#145">145</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="146" href="#146">146</a>         }
<a class="jxr_linenumber" name="147" href="#147">147</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="148" href="#148">148</a>             authStrategy.select(challenges, authhost, response, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="149" href="#149">149</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="150" href="#150">150</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="151" href="#151">151</a>         }
<a class="jxr_linenumber" name="152" href="#152">152</a>     }
<a class="jxr_linenumber" name="153" href="#153">153</a> 
<a class="jxr_linenumber" name="154" href="#154">154</a>     @Test
<a class="jxr_linenumber" name="155" href="#155">155</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testSelectNoSchemeRegistry() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="156" href="#156">156</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="157" href="#157">157</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="158" href="#158">158</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"locahost"</span>, 80);
<a class="jxr_linenumber" name="159" href="#159">159</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="160" href="#160">160</a> 
<a class="jxr_linenumber" name="161" href="#161">161</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Header&gt;();
<a class="jxr_linenumber" name="162" href="#162">162</a>         challenges.put(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=\&quot;test\&quot;"</span>));
<a class="jxr_linenumber" name="163" href="#163">163</a>         challenges.put(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Digest realm=\&quot;realm1\&quot;, nonce=\&quot;1234\&quot;"</span>));
<a class="jxr_linenumber" name="164" href="#164">164</a> 
<a class="jxr_linenumber" name="165" href="#165">165</a>         <strong class="jxr_keyword">final</strong> Queue&lt;AuthOption&gt; options = authStrategy.select(challenges, authhost, response, context);
<a class="jxr_linenumber" name="166" href="#166">166</a>         Assert.assertNotNull(options);
<a class="jxr_linenumber" name="167" href="#167">167</a>         Assert.assertEquals(0, options.size());
<a class="jxr_linenumber" name="168" href="#168">168</a>     }
<a class="jxr_linenumber" name="169" href="#169">169</a> 
<a class="jxr_linenumber" name="170" href="#170">170</a>     @Test
<a class="jxr_linenumber" name="171" href="#171">171</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testSelectNoCredentialsProvider() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="172" href="#172">172</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="173" href="#173">173</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="174" href="#174">174</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"locahost"</span>, 80);
<a class="jxr_linenumber" name="175" href="#175">175</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="176" href="#176">176</a> 
<a class="jxr_linenumber" name="177" href="#177">177</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Header&gt;();
<a class="jxr_linenumber" name="178" href="#178">178</a>         challenges.put(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=\&quot;test\&quot;"</span>));
<a class="jxr_linenumber" name="179" href="#179">179</a>         challenges.put(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Digest realm=\&quot;realm1\&quot;, nonce=\&quot;1234\&quot;"</span>));
<a class="jxr_linenumber" name="180" href="#180">180</a> 
<a class="jxr_linenumber" name="181" href="#181">181</a>         <strong class="jxr_keyword">final</strong> Registry&lt;AuthSchemeProvider&gt; authSchemeRegistry = RegistryBuilder.&lt;AuthSchemeProvider&gt;create()
<a class="jxr_linenumber" name="182" href="#182">182</a>             .register(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicSchemeFactory())
<a class="jxr_linenumber" name="183" href="#183">183</a>             .register(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> DigestSchemeFactory()).build();
<a class="jxr_linenumber" name="184" href="#184">184</a>         context.setAttribute(ClientContext.AUTHSCHEME_REGISTRY, authSchemeRegistry);
<a class="jxr_linenumber" name="185" href="#185">185</a> 
<a class="jxr_linenumber" name="186" href="#186">186</a>         <strong class="jxr_keyword">final</strong> Queue&lt;AuthOption&gt; options = authStrategy.select(challenges, authhost, response, context);
<a class="jxr_linenumber" name="187" href="#187">187</a>         Assert.assertNotNull(options);
<a class="jxr_linenumber" name="188" href="#188">188</a>         Assert.assertEquals(0, options.size());
<a class="jxr_linenumber" name="189" href="#189">189</a>     }
<a class="jxr_linenumber" name="190" href="#190">190</a> 
<a class="jxr_linenumber" name="191" href="#191">191</a>     @Test
<a class="jxr_linenumber" name="192" href="#192">192</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testNoCredentials() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="193" href="#193">193</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="194" href="#194">194</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="195" href="#195">195</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"locahost"</span>, 80);
<a class="jxr_linenumber" name="196" href="#196">196</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="197" href="#197">197</a> 
<a class="jxr_linenumber" name="198" href="#198">198</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Header&gt;();
<a class="jxr_linenumber" name="199" href="#199">199</a>         challenges.put(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=\&quot;realm1\&quot;"</span>));
<a class="jxr_linenumber" name="200" href="#200">200</a>         challenges.put(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Digest realm=\&quot;realm2\&quot;, nonce=\&quot;1234\&quot;"</span>));
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>         <strong class="jxr_keyword">final</strong> Registry&lt;AuthSchemeProvider&gt; authSchemeRegistry = RegistryBuilder.&lt;AuthSchemeProvider&gt;create()
<a class="jxr_linenumber" name="203" href="#203">203</a>             .register(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicSchemeFactory())
<a class="jxr_linenumber" name="204" href="#204">204</a>             .register(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> DigestSchemeFactory()).build();
<a class="jxr_linenumber" name="205" href="#205">205</a>         context.setAttribute(ClientContext.AUTHSCHEME_REGISTRY, authSchemeRegistry);
<a class="jxr_linenumber" name="206" href="#206">206</a> 
<a class="jxr_linenumber" name="207" href="#207">207</a>         <strong class="jxr_keyword">final</strong> CredentialsProvider credentialsProvider = <strong class="jxr_keyword">new</strong> BasicCredentialsProvider();
<a class="jxr_linenumber" name="208" href="#208">208</a>         context.setAttribute(ClientContext.CREDS_PROVIDER, credentialsProvider);
<a class="jxr_linenumber" name="209" href="#209">209</a> 
<a class="jxr_linenumber" name="210" href="#210">210</a>         <strong class="jxr_keyword">final</strong> Queue&lt;AuthOption&gt; options = authStrategy.select(challenges, authhost, response, context);
<a class="jxr_linenumber" name="211" href="#211">211</a>         Assert.assertNotNull(options);
<a class="jxr_linenumber" name="212" href="#212">212</a>         Assert.assertEquals(0, options.size());
<a class="jxr_linenumber" name="213" href="#213">213</a>     }
<a class="jxr_linenumber" name="214" href="#214">214</a> 
<a class="jxr_linenumber" name="215" href="#215">215</a>     @Test
<a class="jxr_linenumber" name="216" href="#216">216</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCredentialsFound() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="217" href="#217">217</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="218" href="#218">218</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="219" href="#219">219</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="220" href="#220">220</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="221" href="#221">221</a> 
<a class="jxr_linenumber" name="222" href="#222">222</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Header&gt;();
<a class="jxr_linenumber" name="223" href="#223">223</a>         challenges.put(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=\&quot;realm1\&quot;"</span>));
<a class="jxr_linenumber" name="224" href="#224">224</a>         challenges.put(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Digest realm=\&quot;realm2\&quot;, nonce=\&quot;1234\&quot;"</span>));
<a class="jxr_linenumber" name="225" href="#225">225</a> 
<a class="jxr_linenumber" name="226" href="#226">226</a>         <strong class="jxr_keyword">final</strong> Registry&lt;AuthSchemeProvider&gt; authSchemeRegistry = RegistryBuilder.&lt;AuthSchemeProvider&gt;create()
<a class="jxr_linenumber" name="227" href="#227">227</a>             .register(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicSchemeFactory())
<a class="jxr_linenumber" name="228" href="#228">228</a>             .register(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> DigestSchemeFactory()).build();
<a class="jxr_linenumber" name="229" href="#229">229</a>         context.setAttribute(ClientContext.AUTHSCHEME_REGISTRY, authSchemeRegistry);
<a class="jxr_linenumber" name="230" href="#230">230</a> 
<a class="jxr_linenumber" name="231" href="#231">231</a>         <strong class="jxr_keyword">final</strong> CredentialsProvider credentialsProvider = <strong class="jxr_keyword">new</strong> BasicCredentialsProvider();
<a class="jxr_linenumber" name="232" href="#232">232</a>         credentialsProvider.setCredentials(<strong class="jxr_keyword">new</strong> AuthScope(<span class="jxr_string">"somehost"</span>, 80, <span class="jxr_string">"realm2"</span>),
<a class="jxr_linenumber" name="233" href="#233">233</a>                 <strong class="jxr_keyword">new</strong> UsernamePasswordCredentials(<span class="jxr_string">"user"</span>, <span class="jxr_string">"pwd"</span>));
<a class="jxr_linenumber" name="234" href="#234">234</a>         context.setAttribute(ClientContext.CREDS_PROVIDER, credentialsProvider);
<a class="jxr_linenumber" name="235" href="#235">235</a> 
<a class="jxr_linenumber" name="236" href="#236">236</a>         <strong class="jxr_keyword">final</strong> Queue&lt;AuthOption&gt; options = authStrategy.select(challenges, authhost, response, context);
<a class="jxr_linenumber" name="237" href="#237">237</a>         Assert.assertNotNull(options);
<a class="jxr_linenumber" name="238" href="#238">238</a>         Assert.assertEquals(1, options.size());
<a class="jxr_linenumber" name="239" href="#239">239</a>         <strong class="jxr_keyword">final</strong> AuthOption option = options.remove();
<a class="jxr_linenumber" name="240" href="#240">240</a>         Assert.assertTrue(option.getAuthScheme() instanceof DigestScheme);
<a class="jxr_linenumber" name="241" href="#241">241</a>     }
<a class="jxr_linenumber" name="242" href="#242">242</a> 
<a class="jxr_linenumber" name="243" href="#243">243</a>     @Test
<a class="jxr_linenumber" name="244" href="#244">244</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testUnsupportedScheme() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="245" href="#245">245</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="246" href="#246">246</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="247" href="#247">247</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="248" href="#248">248</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="249" href="#249">249</a> 
<a class="jxr_linenumber" name="250" href="#250">250</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Header&gt;();
<a class="jxr_linenumber" name="251" href="#251">251</a>         challenges.put(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=\&quot;realm1\&quot;"</span>));
<a class="jxr_linenumber" name="252" href="#252">252</a>         challenges.put(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Digest realm=\&quot;realm2\&quot;, nonce=\&quot;1234\&quot;"</span>));
<a class="jxr_linenumber" name="253" href="#253">253</a>         challenges.put(<span class="jxr_string">"whatever"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Whatever realm=\&quot;realm3\&quot;"</span>));
<a class="jxr_linenumber" name="254" href="#254">254</a> 
<a class="jxr_linenumber" name="255" href="#255">255</a>         <strong class="jxr_keyword">final</strong> Registry&lt;AuthSchemeProvider&gt; authSchemeRegistry = RegistryBuilder.&lt;AuthSchemeProvider&gt;create()
<a class="jxr_linenumber" name="256" href="#256">256</a>             .register(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicSchemeFactory())
<a class="jxr_linenumber" name="257" href="#257">257</a>             .register(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> DigestSchemeFactory()).build();
<a class="jxr_linenumber" name="258" href="#258">258</a>         context.setAttribute(ClientContext.AUTHSCHEME_REGISTRY, authSchemeRegistry);
<a class="jxr_linenumber" name="259" href="#259">259</a> 
<a class="jxr_linenumber" name="260" href="#260">260</a>         <strong class="jxr_keyword">final</strong> CredentialsProvider credentialsProvider = <strong class="jxr_keyword">new</strong> BasicCredentialsProvider();
<a class="jxr_linenumber" name="261" href="#261">261</a>         credentialsProvider.setCredentials(<strong class="jxr_keyword">new</strong> AuthScope(<span class="jxr_string">"somehost"</span>, 80),
<a class="jxr_linenumber" name="262" href="#262">262</a>                 <strong class="jxr_keyword">new</strong> UsernamePasswordCredentials(<span class="jxr_string">"user"</span>, <span class="jxr_string">"pwd"</span>));
<a class="jxr_linenumber" name="263" href="#263">263</a>         context.setAttribute(ClientContext.CREDS_PROVIDER, credentialsProvider);
<a class="jxr_linenumber" name="264" href="#264">264</a> 
<a class="jxr_linenumber" name="265" href="#265">265</a>         <strong class="jxr_keyword">final</strong> Queue&lt;AuthOption&gt; options = authStrategy.select(challenges, authhost, response, context);
<a class="jxr_linenumber" name="266" href="#266">266</a>         Assert.assertNotNull(options);
<a class="jxr_linenumber" name="267" href="#267">267</a>         Assert.assertEquals(2, options.size());
<a class="jxr_linenumber" name="268" href="#268">268</a>         <strong class="jxr_keyword">final</strong> AuthOption option1 = options.remove();
<a class="jxr_linenumber" name="269" href="#269">269</a>         Assert.assertTrue(option1.getAuthScheme() instanceof DigestScheme);
<a class="jxr_linenumber" name="270" href="#270">270</a>         <strong class="jxr_keyword">final</strong> AuthOption option2 = options.remove();
<a class="jxr_linenumber" name="271" href="#271">271</a>         Assert.assertTrue(option2.getAuthScheme() instanceof BasicScheme);
<a class="jxr_linenumber" name="272" href="#272">272</a>     }
<a class="jxr_linenumber" name="273" href="#273">273</a> 
<a class="jxr_linenumber" name="274" href="#274">274</a>     @Test
<a class="jxr_linenumber" name="275" href="#275">275</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCustomAuthPreference() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="276" href="#276">276</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="277" href="#277">277</a>         <strong class="jxr_keyword">final</strong> HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, HttpStatus.SC_UNAUTHORIZED, <span class="jxr_string">"UNAUTHORIZED"</span>);
<a class="jxr_linenumber" name="278" href="#278">278</a>         <strong class="jxr_keyword">final</strong> RequestConfig config = RequestConfig.custom()
<a class="jxr_linenumber" name="279" href="#279">279</a>             .setTargetPreferredAuthSchemes(Arrays.asList(AuthSchemes.BASIC))
<a class="jxr_linenumber" name="280" href="#280">280</a>             .build();
<a class="jxr_linenumber" name="281" href="#281">281</a> 
<a class="jxr_linenumber" name="282" href="#282">282</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="283" href="#283">283</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="284" href="#284">284</a> 
<a class="jxr_linenumber" name="285" href="#285">285</a>         <strong class="jxr_keyword">final</strong> Map&lt;String, Header&gt; challenges = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Header&gt;();
<a class="jxr_linenumber" name="286" href="#286">286</a>         challenges.put(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=\&quot;realm1\&quot;"</span>));
<a class="jxr_linenumber" name="287" href="#287">287</a>         challenges.put(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Digest realm=\&quot;realm2\&quot;, nonce=\&quot;1234\&quot;"</span>));
<a class="jxr_linenumber" name="288" href="#288">288</a> 
<a class="jxr_linenumber" name="289" href="#289">289</a>         <strong class="jxr_keyword">final</strong> Registry&lt;AuthSchemeProvider&gt; authSchemeRegistry = RegistryBuilder.&lt;AuthSchemeProvider&gt;create()
<a class="jxr_linenumber" name="290" href="#290">290</a>             .register(<span class="jxr_string">"basic"</span>, <strong class="jxr_keyword">new</strong> BasicSchemeFactory())
<a class="jxr_linenumber" name="291" href="#291">291</a>             .register(<span class="jxr_string">"digest"</span>, <strong class="jxr_keyword">new</strong> DigestSchemeFactory()).build();
<a class="jxr_linenumber" name="292" href="#292">292</a>         context.setAttribute(ClientContext.AUTHSCHEME_REGISTRY, authSchemeRegistry);
<a class="jxr_linenumber" name="293" href="#293">293</a>         context.setAttribute(ClientContext.REQUEST_CONFIG, config);
<a class="jxr_linenumber" name="294" href="#294">294</a> 
<a class="jxr_linenumber" name="295" href="#295">295</a>         <strong class="jxr_keyword">final</strong> CredentialsProvider credentialsProvider = <strong class="jxr_keyword">new</strong> BasicCredentialsProvider();
<a class="jxr_linenumber" name="296" href="#296">296</a>         credentialsProvider.setCredentials(<strong class="jxr_keyword">new</strong> AuthScope(<span class="jxr_string">"somehost"</span>, 80),
<a class="jxr_linenumber" name="297" href="#297">297</a>                 <strong class="jxr_keyword">new</strong> UsernamePasswordCredentials(<span class="jxr_string">"user"</span>, <span class="jxr_string">"pwd"</span>));
<a class="jxr_linenumber" name="298" href="#298">298</a>         context.setAttribute(ClientContext.CREDS_PROVIDER, credentialsProvider);
<a class="jxr_linenumber" name="299" href="#299">299</a> 
<a class="jxr_linenumber" name="300" href="#300">300</a>         <strong class="jxr_keyword">final</strong> Queue&lt;AuthOption&gt; options = authStrategy.select(challenges, authhost, response, context);
<a class="jxr_linenumber" name="301" href="#301">301</a>         Assert.assertNotNull(options);
<a class="jxr_linenumber" name="302" href="#302">302</a>         Assert.assertEquals(1, options.size());
<a class="jxr_linenumber" name="303" href="#303">303</a>         <strong class="jxr_keyword">final</strong> AuthOption option1 = options.remove();
<a class="jxr_linenumber" name="304" href="#304">304</a>         Assert.assertTrue(option1.getAuthScheme() instanceof BasicScheme);
<a class="jxr_linenumber" name="305" href="#305">305</a>     }
<a class="jxr_linenumber" name="306" href="#306">306</a> 
<a class="jxr_linenumber" name="307" href="#307">307</a>     @Test
<a class="jxr_linenumber" name="308" href="#308">308</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthSucceededInvalidInput() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="309" href="#309">309</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="310" href="#310">310</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"locahost"</span>, 80);
<a class="jxr_linenumber" name="311" href="#311">311</a>         <strong class="jxr_keyword">final</strong> BasicScheme authScheme = <strong class="jxr_keyword">new</strong> BasicScheme();
<a class="jxr_linenumber" name="312" href="#312">312</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="313" href="#313">313</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="314" href="#314">314</a>             authStrategy.authSucceeded(<strong class="jxr_keyword">null</strong>, authScheme, context);
<a class="jxr_linenumber" name="315" href="#315">315</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="316" href="#316">316</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="317" href="#317">317</a>         }
<a class="jxr_linenumber" name="318" href="#318">318</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="319" href="#319">319</a>             authStrategy.authSucceeded(authhost, <strong class="jxr_keyword">null</strong>, context);
<a class="jxr_linenumber" name="320" href="#320">320</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="321" href="#321">321</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="322" href="#322">322</a>         }
<a class="jxr_linenumber" name="323" href="#323">323</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="324" href="#324">324</a>             authStrategy.authSucceeded(authhost, authScheme, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="325" href="#325">325</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="326" href="#326">326</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="327" href="#327">327</a>         }
<a class="jxr_linenumber" name="328" href="#328">328</a>     }
<a class="jxr_linenumber" name="329" href="#329">329</a> 
<a class="jxr_linenumber" name="330" href="#330">330</a>     @Test
<a class="jxr_linenumber" name="331" href="#331">331</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthSucceeded() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="332" href="#332">332</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="333" href="#333">333</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="334" href="#334">334</a>         <strong class="jxr_keyword">final</strong> BasicScheme authScheme = <strong class="jxr_keyword">new</strong> BasicScheme();
<a class="jxr_linenumber" name="335" href="#335">335</a>         authScheme.processChallenge(<strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=test"</span>));
<a class="jxr_linenumber" name="336" href="#336">336</a> 
<a class="jxr_linenumber" name="337" href="#337">337</a>         <strong class="jxr_keyword">final</strong> AuthCache authCache = Mockito.mock(AuthCache.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="338" href="#338">338</a> 
<a class="jxr_linenumber" name="339" href="#339">339</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="340" href="#340">340</a>         context.setAttribute(ClientContext.AUTH_CACHE, authCache);
<a class="jxr_linenumber" name="341" href="#341">341</a> 
<a class="jxr_linenumber" name="342" href="#342">342</a>         authStrategy.authSucceeded(authhost, authScheme, context);
<a class="jxr_linenumber" name="343" href="#343">343</a>         Mockito.verify(authCache).put(authhost, authScheme);
<a class="jxr_linenumber" name="344" href="#344">344</a>     }
<a class="jxr_linenumber" name="345" href="#345">345</a> 
<a class="jxr_linenumber" name="346" href="#346">346</a>     @Test
<a class="jxr_linenumber" name="347" href="#347">347</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthSucceededNoCache() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="348" href="#348">348</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="349" href="#349">349</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="350" href="#350">350</a>         <strong class="jxr_keyword">final</strong> BasicScheme authScheme = <strong class="jxr_keyword">new</strong> BasicScheme();
<a class="jxr_linenumber" name="351" href="#351">351</a>         authScheme.processChallenge(<strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=test"</span>));
<a class="jxr_linenumber" name="352" href="#352">352</a> 
<a class="jxr_linenumber" name="353" href="#353">353</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="354" href="#354">354</a>         context.setAttribute(ClientContext.AUTH_CACHE, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="355" href="#355">355</a> 
<a class="jxr_linenumber" name="356" href="#356">356</a>         authStrategy.authSucceeded(authhost, authScheme, context);
<a class="jxr_linenumber" name="357" href="#357">357</a>         <strong class="jxr_keyword">final</strong> AuthCache authCache = (AuthCache) context.getAttribute(ClientContext.AUTH_CACHE);
<a class="jxr_linenumber" name="358" href="#358">358</a>         Assert.assertNotNull(authCache);
<a class="jxr_linenumber" name="359" href="#359">359</a>     }
<a class="jxr_linenumber" name="360" href="#360">360</a> 
<a class="jxr_linenumber" name="361" href="#361">361</a>     @Test
<a class="jxr_linenumber" name="362" href="#362">362</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthScemeNotCompleted() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="363" href="#363">363</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="364" href="#364">364</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="365" href="#365">365</a>         <strong class="jxr_keyword">final</strong> BasicScheme authScheme = <strong class="jxr_keyword">new</strong> BasicScheme();
<a class="jxr_linenumber" name="366" href="#366">366</a> 
<a class="jxr_linenumber" name="367" href="#367">367</a>         <strong class="jxr_keyword">final</strong> AuthCache authCache = Mockito.mock(AuthCache.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="368" href="#368">368</a> 
<a class="jxr_linenumber" name="369" href="#369">369</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="370" href="#370">370</a>         context.setAttribute(ClientContext.AUTH_CACHE, authCache);
<a class="jxr_linenumber" name="371" href="#371">371</a> 
<a class="jxr_linenumber" name="372" href="#372">372</a>         authStrategy.authSucceeded(authhost, authScheme, context);
<a class="jxr_linenumber" name="373" href="#373">373</a>         Mockito.verify(authCache, Mockito.never()).put(authhost, authScheme);
<a class="jxr_linenumber" name="374" href="#374">374</a>     }
<a class="jxr_linenumber" name="375" href="#375">375</a> 
<a class="jxr_linenumber" name="376" href="#376">376</a>     @Test
<a class="jxr_linenumber" name="377" href="#377">377</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthScemeNonCacheable() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="378" href="#378">378</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="379" href="#379">379</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="380" href="#380">380</a>         <strong class="jxr_keyword">final</strong> AuthScheme authScheme = Mockito.mock(AuthScheme.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="381" href="#381">381</a>         Mockito.when(authScheme.isComplete()).thenReturn(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="382" href="#382">382</a>         Mockito.when(authScheme.getSchemeName()).thenReturn(<span class="jxr_string">"whatever"</span>);
<a class="jxr_linenumber" name="383" href="#383">383</a> 
<a class="jxr_linenumber" name="384" href="#384">384</a>         <strong class="jxr_keyword">final</strong> AuthCache authCache = Mockito.mock(AuthCache.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="385" href="#385">385</a> 
<a class="jxr_linenumber" name="386" href="#386">386</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="387" href="#387">387</a>         context.setAttribute(ClientContext.AUTH_CACHE, authCache);
<a class="jxr_linenumber" name="388" href="#388">388</a> 
<a class="jxr_linenumber" name="389" href="#389">389</a>         authStrategy.authSucceeded(authhost, authScheme, context);
<a class="jxr_linenumber" name="390" href="#390">390</a>         Mockito.verify(authCache, Mockito.never()).put(authhost, authScheme);
<a class="jxr_linenumber" name="391" href="#391">391</a>     }
<a class="jxr_linenumber" name="392" href="#392">392</a> 
<a class="jxr_linenumber" name="393" href="#393">393</a>     @Test
<a class="jxr_linenumber" name="394" href="#394">394</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthFailedInvalidInput() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="395" href="#395">395</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="396" href="#396">396</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"locahost"</span>, 80);
<a class="jxr_linenumber" name="397" href="#397">397</a>         <strong class="jxr_keyword">final</strong> BasicScheme authScheme = <strong class="jxr_keyword">new</strong> BasicScheme();
<a class="jxr_linenumber" name="398" href="#398">398</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="399" href="#399">399</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="400" href="#400">400</a>             authStrategy.authFailed(<strong class="jxr_keyword">null</strong>, authScheme, context);
<a class="jxr_linenumber" name="401" href="#401">401</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="402" href="#402">402</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="403" href="#403">403</a>         }
<a class="jxr_linenumber" name="404" href="#404">404</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="405" href="#405">405</a>             authStrategy.authFailed(authhost, authScheme, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="406" href="#406">406</a>             Assert.fail(<span class="jxr_string">"IllegalArgumentException expected"</span>);
<a class="jxr_linenumber" name="407" href="#407">407</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException ex) {
<a class="jxr_linenumber" name="408" href="#408">408</a>         }
<a class="jxr_linenumber" name="409" href="#409">409</a>     }
<a class="jxr_linenumber" name="410" href="#410">410</a> 
<a class="jxr_linenumber" name="411" href="#411">411</a>     @Test
<a class="jxr_linenumber" name="412" href="#412">412</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthFailed() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="413" href="#413">413</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="414" href="#414">414</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="415" href="#415">415</a>         <strong class="jxr_keyword">final</strong> BasicScheme authScheme = <strong class="jxr_keyword">new</strong> BasicScheme();
<a class="jxr_linenumber" name="416" href="#416">416</a>         authScheme.processChallenge(<strong class="jxr_keyword">new</strong> BasicHeader(AUTH.WWW_AUTH, <span class="jxr_string">"Basic realm=test"</span>));
<a class="jxr_linenumber" name="417" href="#417">417</a> 
<a class="jxr_linenumber" name="418" href="#418">418</a>         <strong class="jxr_keyword">final</strong> AuthCache authCache = Mockito.mock(AuthCache.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="419" href="#419">419</a> 
<a class="jxr_linenumber" name="420" href="#420">420</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="421" href="#421">421</a>         context.setAttribute(ClientContext.AUTH_CACHE, authCache);
<a class="jxr_linenumber" name="422" href="#422">422</a> 
<a class="jxr_linenumber" name="423" href="#423">423</a>         authStrategy.authFailed(authhost, authScheme, context);
<a class="jxr_linenumber" name="424" href="#424">424</a>         Mockito.verify(authCache).remove(authhost);
<a class="jxr_linenumber" name="425" href="#425">425</a>     }
<a class="jxr_linenumber" name="426" href="#426">426</a> 
<a class="jxr_linenumber" name="427" href="#427">427</a>     @Test
<a class="jxr_linenumber" name="428" href="#428">428</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAuthFailedNoCache() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="429" href="#429">429</a>         <strong class="jxr_keyword">final</strong> TargetAuthenticationStrategy authStrategy = <strong class="jxr_keyword">new</strong> TargetAuthenticationStrategy();
<a class="jxr_linenumber" name="430" href="#430">430</a>         <strong class="jxr_keyword">final</strong> HttpHost authhost = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"somehost"</span>, 80);
<a class="jxr_linenumber" name="431" href="#431">431</a>         <strong class="jxr_keyword">final</strong> BasicScheme authScheme = <strong class="jxr_keyword">new</strong> BasicScheme();
<a class="jxr_linenumber" name="432" href="#432">432</a> 
<a class="jxr_linenumber" name="433" href="#433">433</a>         <strong class="jxr_keyword">final</strong> HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="434" href="#434">434</a>         context.setAttribute(ClientContext.AUTH_CACHE, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="435" href="#435">435</a> 
<a class="jxr_linenumber" name="436" href="#436">436</a>         authStrategy.authFailed(authhost, authScheme, context);
<a class="jxr_linenumber" name="437" href="#437">437</a>     }
<a class="jxr_linenumber" name="438" href="#438">438</a> 
<a class="jxr_linenumber" name="439" href="#439">439</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

